//
//  searchListModel.h
//  Private-X
//
//  Created by xd h on 2025/3/19.
//

#import "SuperModel.h"

NS_ASSUME_NONNULL_BEGIN

@interface searchDataModel : SuperModel
@property (nonatomic, copy) NSString*path;
@property (nonatomic, copy) NSString*name;
//@property (nonatomic, assign) long time;//NSString*time;
@property (nonatomic, copy) NSString*time;
@property (nonatomic, assign) long  size;
@property (nonatomic, copy) NSString*type;
@property (nonatomic, assign) NSInteger duration;

//自定义
@property (nonatomic, assign) BOOL isSelectType;
@property (nonatomic, assign) BOOL isDidCacheType;//是否有缓存
@property (nonatomic, assign) BOOL isOffLineType;//是否离线状态
@end

@protocol searchDataModel;
@interface searchListTotaModel : SuperModel
@property (nonatomic, assign) NSInteger total;
@property (nonatomic, strong) NSArray<searchDataModel>* list;
@end

@interface searchListModel : SuperModel
@property (nonatomic, strong) searchListTotaModel* data;
@end

NS_ASSUME_NONNULL_END
