//
//  searchBarThridTypeView.m
//  Private-X
//
//  Created by xd h on 2025/3/20.
//

#import "searchBarThridTypeView.h"

@interface searchBarThridTypeView ()
@property(nonatomic,strong) UITextField*searchTF;
@end

@implementation searchBarThridTypeView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    
    //self.backgroundColor = [UIColor clearColor];
    [self drawAnyView];
    
    return self;
}

-(void)drawAnyView
{
    UIView *whiteBgView = [[UIView alloc] init];
    whiteBgView.backgroundColor = [UIColor hwColor:@"#F9F9F9"];
    [self addSubview:whiteBgView];
    whiteBgView.layer.cornerRadius = 8;
    whiteBgView.layer.masksToBounds = YES;
    
    [whiteBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(0);
        make.left.mas_equalTo(0);
        //make.right.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
    }];
    
    //添加手势事件
    [whiteBgView addGestureRecognizer:[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(didClickWhiteViewFun)]];
    
    //搜索小图标
    UIImageView *imageView = [[UIImageView alloc] init];
    imageView.image = [UIImage imageNamed:@"home_search_icon"];
    [whiteBgView addSubview:imageView];
    
    [imageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(24);
        make.height.mas_equalTo(24);
        make.left.mas_equalTo(9);
        make.centerY.mas_equalTo(0);
    }];
    
    //搜索TF
    NSString *titleStr = NSLocalizedString(@"Search_nas_title",nil);
    _searchTF = [[UITextField alloc] init];
    _searchTF.backgroundColor = [UIColor clearColor];
    _searchTF.placeholder = titleStr;
    _searchTF.font = [UIFont systemFontOfSize:12];
    //_searchTF.delegate = self;
    _searchTF.userInteractionEnabled = NO;
    [whiteBgView addSubview:_searchTF];

    [_searchTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(imageView.mas_right).offset(2);
        make.top.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
    }];
    
}

//#pragma mark UITextFieldDelegate
//- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
//      NSString *beString = [textField.text stringByReplacingCharactersInRange:range withString:string];
//    
//    if([beString length] >0){
//        _searchButton.enabled = YES;
//    }
//    else{
//        _searchButton.enabled = NO;
//    }
//    
//    if ([beString length] > 16) {
//      textField.text = [beString substringToIndex:16];
//      return NO;
//    }
//    return YES;
//}
//
//- (BOOL)textFieldShouldReturn:(UITextField *)textField{
//    [textField resignFirstResponder];
//    return YES;
//}

//- (void)didClickSearchButFun{
//    if (_didClickSearchFun) {
//        NSString *string = _searchTF.text;
//        _didClickSearchFun(string);
//    }
//    
//    [_searchTF resignFirstResponder];
//}

- (void)didClickWhiteViewFun
{
    if (_didClickBgFun) {
        _didClickBgFun();
    }
}

@end

